"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.coinGeckoClient = void 0;
const coingecko_api_v3_1 = require("coingecko-api-v3");
const ccxt_1 = __importDefault(require("ccxt"));
const coinGeckoClient = () => {
    const bin = new ccxt_1.default.binanceus({});
    const client = new coingecko_api_v3_1.CoinGeckoClient({
        timeout: 10000,
        autoRetry: true,
    });
    return {
        getRenderPriceAtDate(p) {
            var _a, _b, _c;
            return __awaiter(this, void 0, void 0, function* () {
                let { symbol, ts } = Object.assign(Object.assign({}, p), { symbol: (_a = p.symbol) !== null && _a !== void 0 ? _a : "RNDR/USDT", 
                    // @ts-ignore
                    ex: (_b = p.ex) !== null && _b !== void 0 ? _b : 'binance' });
                const resp = yield bin.fetchOHLCV(symbol, '1m', ts.getTime(), 1, undefined);
                // close
                return Number((_c = resp[0][4]) === null || _c === void 0 ? void 0 : _c.toString());
            });
        },
        getCurrPrice() {
            var _a;
            return __awaiter(this, void 0, void 0, function* () {
                const res = yield client.coinId({ id: 'render-token' });
                return (_a = res.market_data) === null || _a === void 0 ? void 0 : _a.current_price['usd'];
            });
        }
    };
};
exports.coinGeckoClient = coinGeckoClient;
//# sourceMappingURL=priceClient.js.map