"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fetchEthInfo = void 0;
const anchor = __importStar(require("@coral-xyz/anchor"));
const wormhole_sdk_1 = require("@certusone/wormhole-sdk");
const logger_1 = require("./logger");
const fetchEthInfo = (seq, wormEnv = 'MAINNET', ethChainId = 2, retries = 3, log = logger_1.consoleLogger) => __awaiter(void 0, void 0, void 0, function* () {
    const hexEmitter = Buffer.alloc(32)
        .fill(Uint8Array.from(anchor.utils.bytes.hex.decode(wormhole_sdk_1.CONTRACTS[wormEnv].ethereum.token_bridge)), 12)
        .toString('hex');
    const url = `https://api${wormEnv.toLowerCase() == 'mainnet' ? '' : `.${wormEnv.toString().toLowerCase()}`}.wormholescan.io/api/v1/global-tx/${ethChainId}/${hexEmitter}/${seq}`;
    const recur = (currRetry = 0) => __awaiter(void 0, void 0, void 0, function* () {
        if (currRetry == retries) {
            return Promise.reject(new Error(`wormapi exceeded max retries ${retries} fetching ${url}`));
        }
        try {
            const res = yield fetch(url).then((res) => __awaiter(void 0, void 0, void 0, function* () {
                if (res.status != 200) {
                    throw new Error(`status code ${res.status} fetching ${url}. body: ${JSON.stringify(yield res.json())}`);
                }
                return (yield res.json());
            }), err => {
                throw new Error(`exception fetching wormapi: ${JSON.stringify(err)}`);
            });
            return [seq, res];
        }
        catch (e) {
            // @ts-ignore
            log.error(`wormapi err ${e.message}`);
            return recur(currRetry + 1);
        }
    });
    return (yield recur());
});
exports.fetchEthInfo = fetchEthInfo;
//# sourceMappingURL=wormhole.js.map