import { CoinGeckoClient } from "coingecko-api-v3";
import ccxt from "ccxt";
export const coinGeckoClient = () => {
    const bin = new ccxt.binanceus({});
    const client = new CoinGeckoClient({
        timeout: 10000,
        autoRetry: true,
    });
    return {
        async getRenderPriceAtDate(p) {
            let { symbol, ts } = {
                ...p,
                symbol: p.symbol ?? "RNDR/USDT",
                // @ts-ignore
                ex: p.ex ?? 'binance'
            };
            const resp = await bin.fetchOHLCV(symbol, '1m', ts.getTime(), 1, undefined);
            // close
            return Number(resp[0][4]?.toString());
            /*const res = await client.coinIdHistory({
              id: 'render-token',
              date: `${d.getDate()}-${d.getMonth() + 1}-${d.getFullYear()}`
            })
            return res.market_data.current_price!['usd']*/
        },
        async getCurrPrice() {
            const res = await client.coinId({ id: 'render-token' });
            return res.market_data?.current_price['usd'];
        }
    };
};
//# sourceMappingURL=priceClient.js.map